/*
 * File:        exiftool.c
 *
 * Description: Simple program to launch the pure Perl version of exiftool
 *
 * Revisions:   2011/09/15 - P. Harvey Created
 */

#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

/* Perl executable name */
#define PERLNAME    "perl"

/* full path to exiftool script */
#define EXIFTOOL    "c:\\windows\\exiftool.pl"

int main(int argc, char **argv)
{
    /* generate our argument list */
    char **args = (char **)malloc((argc+2) * sizeof(char**));
    int i;
    args[0] = PERLNAME;     /* we are calling Perl */
    args[1] = EXIFTOOL;     /* to launch our exiftool script */

    /* copy over the rest of our arguments */
    for (i=1; i<argc; ++i) {
        args[i+1] = argv[i];
    }
    args[argc+1] = NULL;    /* NULL ends argument list */

    /*
     * execute Perl to run exiftool
     *
     * NOTE: the cast here is done to prevent an "incompatible pointer type"
     * error when compiled with mingw.  You may need to remove this for
     * other compilers.
     */
    execvp(PERLNAME, (const char * const *)args); /* should never return */
    
    fprintf(stderr, "Error executing %s\n", PERLNAME);
    
    return(1);
}
